/*------------------------------------------------------------------------------
-- This file is a part of the QLop Software
-- Copyright (C) 2015, Plasma Physics Laboratory - CNRS
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
-------------------------------------------------------------------------------*/
/*-- Author : Alexis Jeandet
-- Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#ifndef FILEDOWNLOADER_H
#define FILEDOWNLOADER_H

#include <QObject>
#include <QByteArray>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QProgressBar>
#include <QLabel>
#include <QHBoxLayout>
class FileDownloader : public QObject
{
  Q_OBJECT
public:
  explicit FileDownloader(QUrl fileUrl,const QString& name,QObject *parent = 0);
  ~FileDownloader();

  QByteArray downloadedData() const;
  void clearData();
  int donloadedDataSize();
  QWidget *getProgressBar();
  QString fileName();
  bool downloadComplete();
signals:
  void downloaded();

private slots:

  void fileDownloaded(QNetworkReply* pReply);
  void downloadProgress(qint64 bytesSent, qint64 bytesTotal);
private:
  QProgressBar m_progressBar;
  QString m_fileName;
  QLabel m_label;
  QWidget m_widget;
  QHBoxLayout m_layout;
  QNetworkAccessManager m_WebCtrl;
  QNetworkReply* m_Reply;
  QByteArray m_DownloadedData;
  bool m_downloadComplete;
};

#endif // FILEDOWNLOADER_H
